/*
 *	piecese/piecese.cpp - P/ECEΉVFgDLL
 *
 *	{vO쐬ɂẮAuł̗bӂƂ͂v(http://www.runan.net/) 
 *	[vO~OTips]->[C++ SDK Tips]->[VFgV[Y]QlɂĒ܂B
 *	҂̃iɁAӂ܂B
 *
 *	* Thu Jan 31 19:10:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "stdafx.h"
#include "piecese.h"

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

#define PROGID_PieceSE		"PieceSE"
#define CLSID_PieceSE_STRING	"{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}"
GUID CLSID_PieceSE = { 0xb5f50e0a, 0x9c39, 0x48bc, { 0x90, 0xc5, 0xf2, 0x18, 0xd6, 0xf9, 0x79, 0xe8 } };

HINSTANCE g_inst = NULL;	/* DLL̃CX^X */
UINT g_ref = 0;			/* QƃJEg */

/****************************************************************************
 *	DllMain
 ****************************************************************************/

BOOL APIENTRY
DllMain(HINSTANCE hInstance, DWORD  dwReason, LPVOID /*lpReserved*/)
{
	if(dwReason == DLL_PROCESS_ATTACH) {
		g_inst = hInstance;
	}
	return 1; /*  */
}

/****************************************************************************
 *	DllCanUnloadNow
 ****************************************************************************/

STDAPI
DllCanUnloadNow()
{
	/* QƃJEg0ȂS_OKB */
	return g_ref == 0 ? S_OK : S_FALSE;
}

/****************************************************************************
 *	DllCanClassObject
 ****************************************************************************/

STDAPI
DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppvOut)
{
	CPieceSEClassFactory* pcf;
	*ppvOut = NULL;
	if(rclsid == CLSID_PieceSE) {
		/* NXt@Ng̍쐬B */
		pcf = new CPieceSEClassFactory;
		return pcf->QueryInterface(riid, ppvOut);
	}
	/* sCLASS_E_CLASSNOTAVAILABLEԂB */
	return CLASS_E_CLASSNOTAVAILABLE;
}

/****************************************************************************
 *	DllRegisterServer
 ****************************************************************************/

#define KEY_PEX			".pex"
#define VALUE_PEX		PROGID_PieceSE
#define KEY_PROGID_PIECESE	PROGID_PieceSE
#define KEY_DEFAULT_ICON	"DefaultIcon"
#define VALUE_DEFAULT_ICON	"%1"
#define KEY_SHELLEX		"ShellEx"
#define KEY_ICON_HANDLER	"IconHandler"
#define VALUE_ICON_HANDLER	CLSID_PieceSE_STRING
#define KEY_CLSID		"CLSID"
#define KEY_CLSID_PIECESE	CLSID_PieceSE_STRING
#define VALUE_CLSID_PIECESE	PROGID_PieceSE
#define KEY_INPROC_SERVER	"InprocServer32"
#define NAME_THREADING_MODEL	"ThreadingModel"
#define VALUE_THREADING_MODEL	"Apartment"

STDAPI
DllRegisterServer()
{
	int result;
	char path[_MAX_PATH];
/*1*/	HKEY keyPex = NULL;
/*2*/	HKEY keyProgIdPieceSE = NULL;
/*3*/	HKEY keyDefaultIcon = NULL;
/*4*/	HKEY keyShellEx = NULL;
/*5*/	HKEY keyIconHandler = NULL;
/*6*/	HKEY keyClsId = NULL;
/*7*/	HKEY keyClsIdPieceSE = NULL;
/*8*/	HKEY keyInprocServer = NULL;

	result = E_FAIL;

#define KEY(p, k, hk)	if(RegCreateKey((p), (k), &(hk)) != ERROR_SUCCESS) goto ERR;
#define VAL(hk, v)	if(RegSetValue((hk), NULL, REG_SZ, v, strlen(v))) goto ERR;
#define VAL2(hk, n, v)	if(RegSetValueEx((hk), (n), 0, REG_SZ, (LPBYTE)(v), strlen(v))) goto ERR;

	/* HKEY_CLASSES_ROOT
	 * + .pex = PieceSE
	 */
	KEY(HKEY_CLASSES_ROOT, KEY_PEX, keyPex); 
	VAL(                            keyPex, KEY_PROGID_PIECESE);

	/* HKEY_CLASSES_ROOT
	 * + PieceSE
	 *   + DefaultIcon = %1
	 *   + ShellEx
	 *     + IconHandleer = {GUID}
	 */
	KEY(HKEY_CLASSES_ROOT, KEY_PROGID_PIECESE, keyProgIdPieceSE);
	KEY(                                       keyProgIdPieceSE, KEY_DEFAULT_ICON, keyDefaultIcon);
	VAL(                                                                           keyDefaultIcon, VALUE_DEFAULT_ICON);
	KEY(                                       keyProgIdPieceSE, KEY_SHELLEX, keyShellEx);
	KEY(                                                                      keyShellEx, KEY_ICON_HANDLER, keyIconHandler);
	VAL(                                                                                                    keyIconHandler, VALUE_ICON_HANDLER);

	/* HKEY_CLASSES_ROOT
	 * + CLSID
	 *   + {GUID} = PieceSE
	 *     + InprocServer32 = (path)
	 *       (ThreadingModel) = Apartment
	 */
	KEY(HKEY_CLASSES_ROOT, KEY_CLSID, keyClsId); 
	KEY(                              keyClsId, KEY_CLSID_PIECESE, keyClsIdPieceSE); 
	VAL(                                                           keyClsIdPieceSE, VALUE_CLSID_PIECESE);
	KEY(                                                           keyClsIdPieceSE, KEY_INPROC_SERVER, keyInprocServer); 
	if(GetModuleFileName(g_inst, path, sizeof path) == 0) goto ERR;
	VAL(                                                                                               keyInprocServer, path);
	VAL2(                                                                                              keyInprocServer, NAME_THREADING_MODEL, VALUE_THREADING_MODEL);

#undef VAL
#undef KEY

	result = S_OK;
ERR:
/*8*/	if(keyInprocServer != NULL) RegCloseKey(keyInprocServer);
/*7*/	if(keyClsIdPieceSE != NULL) RegCloseKey(keyClsIdPieceSE);
/*6*/	if(keyClsId != NULL) RegCloseKey(keyClsId);
/*5*/	if(keyIconHandler != NULL) RegCloseKey(keyIconHandler);
/*4*/	if(keyShellEx != NULL) RegCloseKey(keyShellEx);
/*3*/	if(keyDefaultIcon != NULL) RegCloseKey(keyDefaultIcon);
/*2*/	if(keyProgIdPieceSE != NULL) RegCloseKey(keyProgIdPieceSE);
/*1*/	if(keyPex != NULL) RegCloseKey(keyPex);

	return result;
}

/****************************************************************************
 *	DllUnregisterServer
 ****************************************************************************/

static BOOL
DelKey(HKEY hKey, LPCTSTR szSubKey)
{
	char buf[1024];
	HKEY hSubKey;

	/* TuL[JB */
	if(RegOpenKey(hKey, szSubKey, &hSubKey) != ERROR_SUCCESS) return FALSE;
	/* TuL[ł邱ƂmFB */
	if(RegEnumKey(hSubKey, 0, buf, sizeof buf) == ERROR_SUCCESS) {
		RegCloseKey(hSubKey);
		return FALSE;
	}
	/* TuL[B */
	RegCloseKey(hSubKey);
	/* TuL[폜B */
	return RegDeleteKey(hKey, szSubKey) == ERROR_SUCCESS;
}

STDAPI
DllUnregisterServer()
{
	HKEY key1, key2;

	/* HKEY_CLASSES_ROOT
	 * + .pex = PieceSE
	 */
	DelKey(HKEY_CLASSES_ROOT, KEY_PEX);	/* .pex̓TuL[Ȃ̂łȂ */

	/* HKEY_CLASSES_ROOT
	 * + PieceSE
	 *   + DefaultIcon = %1
	 *   + ShellEx
	 *     + IconHandleer = {GUID}
	 */
	if(RegOpenKey(HKEY_CLASSES_ROOT, KEY_PROGID_PIECESE, &key1) == ERROR_SUCCESS) {	/* PieceSEJāA */
		DelKey(key1, KEY_DEFAULT_ICON);						/* DefaultIcon */
		if(RegOpenKey(key1, KEY_SHELLEX, &key2) == ERROR_SUCCESS) {		/* ShellExJāA */
			DelKey(key2, KEY_ICON_HANDLER);					/* IconHandler */
			RegCloseKey(key2);						/* ShellEx */
		}
		DelKey(key1, KEY_SHELLEX);						/* ShellEx */
		RegCloseKey(key1);							/* PieceSE */
	}
	DelKey(HKEY_CLASSES_ROOT, KEY_PROGID_PIECESE);					/* PieceSE */

	/* HKEY_CLASSES_ROOT
	 * + CLSID
	 *   + {GUID} = PieceSE
	 *     + InprocServer32 = (path)
	 *       (ThreadingModel) = Apartment
	 */
	if(RegOpenKey(HKEY_CLASSES_ROOT, KEY_CLSID, &key1) == ERROR_SUCCESS) {		/* CLSIDJ */
		if(RegOpenKey(key1, KEY_CLSID_PIECESE, &key2) == ERROR_SUCCESS) {	/* {GUID}J */
			DelKey(key2, KEY_INPROC_SERVER);				/* InprocServer32 */
			RegCloseKey(key2);						/* {GUID} */
		}
		DelKey(key1, KEY_CLSID_PIECESE);					/* {GUID} */
		RegCloseKey(key1);							/* CLSID(CLSID͍Ȃ!!) */
	}

	return S_OK;
}

/****************************************************************************
 *	CPieceSEClassFactory
 ****************************************************************************/

CPieceSEClassFactory::CPieceSEClassFactory()
{
	g_ref++;
	m_ref = 0;
}

CPieceSEClassFactory::~CPieceSEClassFactory()
{
	g_ref--;
}

STDMETHODIMP
CPieceSEClassFactory::QueryInterface(REFIID riid, LPVOID* ppvObj)
{
	*ppvObj = NULL;
	if(riid == IID_IUnknown || riid == IID_IClassFactory) {
		*ppvObj = (IClassFactory*)this;
	}
	if(*ppvObj != NULL) {
		AddRef(); /* YȂ! */
		return S_OK;
	}
	return E_NOINTERFACE;
}

STDMETHODIMP_(ULONG)
CPieceSEClassFactory::AddRef()
{
	return ++m_ref;
}

STDMETHODIMP_(ULONG)
CPieceSEClassFactory::Release()
{
	if(--m_ref == 0) {
		delete this;
		return 0;
	}
	return m_ref;
}

STDMETHODIMP
CPieceSEClassFactory::CreateInstance(LPUNKNOWN pUnkOuter, REFIID riid, LPVOID* ppvObj)
{
	CPieceSE* pse;

	*ppvObj = NULL;

	/* WT|[gĂȂ̂ŋpB */
	if(pUnkOuter != NULL) return CLASS_E_NOAGGREGATION;

	/* VFgIuWFNg쐬B */
	pse = new CPieceSE;
	if(pse == NULL) return E_OUTOFMEMORY;

	/* ړĨC^[tFCX̃|C^擾B */
	return pse->QueryInterface(riid, ppvObj);
}

STDMETHODIMP
CPieceSEClassFactory::LockServer(BOOL /*fLock*/)
{
	/* A邾B */
	return S_OK;
}

/****************************************************************************
 *	CPieceSE
 ****************************************************************************/

CPieceSE::CPieceSE()
{
	g_ref++;
	m_ref = 0;
}

CPieceSE::~CPieceSE()
{
	g_ref--;
}

STDMETHODIMP
CPieceSE::QueryInterface(REFIID riid, LPVOID* ppvObj)
{
	*ppvObj = NULL;
	if(riid == IID_IUnknown || riid == IID_IPersist) {
		*ppvObj = (IPersist*)this;
	} else if(riid == IID_IPersistFile) {
		*ppvObj = (IPersistFile*)this;
	} else if(riid == IID_IExtractIcon) {
		*ppvObj = (IExtractIcon*)this;
	}
	if(*ppvObj != NULL) {
		AddRef(); /* YȂ! */
		return S_OK;
	}
	return E_NOINTERFACE;
}

STDMETHODIMP_(ULONG)
CPieceSE::AddRef()
{
	return ++m_ref;
}

STDMETHODIMP_(ULONG)
CPieceSE::Release()
{
	if(--m_ref == 0) {
		delete this;
		return 0;
	}
	return m_ref;
}

STDMETHODIMP
CPieceSE::GetClassID(CLSID* /*pClassID*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::IsDirty()
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::Load(LPCOLESTR lpszFileName, DWORD /*grfMode*/)
{
	/* ACRot@CANSIɕϊĊi[܂B */
	WideCharToMultiByte(
		CP_ACP,			/* ϊR[hy[W=ANSI */
		0,			/* s̈=none */
		lpszFileName,		/* ϊUnicode */
		-1,			/* ϊ=nulI[ */
		m_filename,		/* ϊobt@ */
		sizeof m_filename,	/* ϊoCg */
		NULL,			/* lpDefaultChar=w */
		NULL);			/* lpUsedDefaultChar=w */
	return S_OK;
}

STDMETHODIMP
CPieceSE::Save(LPCOLESTR /*lpszFileName*/, BOOL /*fRemember*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::SaveCompleted(LPCOLESTR /*lpszFileName*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::GetCurFile(LPOLESTR FAR* /*lplpszFileName*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::GetIconLocation(UINT /*uFlags*/, LPSTR szIconFile, UINT cchMax, int* piIndex, UINT* pwFlags)
{
	strncpy(szIconFile, m_filename, cchMax);	/* t@C */
	if(piIndex != NULL) *piIndex = 0;		/* (_~[) */
	if(pwFlags != NULL) *pwFlags = GIL_DONTCACHE	/* VFɃACRLbVȂ */
				     | GIL_NOTFILENAME	/* szIconFile/piIndex͎g킸AExtract()Ăł炤 */
				     | GIL_PERINSTANCE;	/* t@CɕʁX̃ACR\Ă炤 */
	return S_OK;
}

#define ICON_SIZE	32

STDMETHODIMP
CPieceSE::Extract(LPCSTR pszFile, UINT /*nIconIndex*/, HICON* phiconLarge, HICON* phiconSmall, UINT /*nIconSize*/)
{
	int retval, x, y, n;
	FILE* fp;
	pffsFileHEADER hdr;
	unsigned char pid[ICON_SIZE][ICON_SIZE / 4];
	BITMAPINFOHEADER bi;
	HBITMAP image, mask;
	unsigned char *bits, *pixel;
	BITMAP bm;
	ICONINFO icon;

	if(phiconLarge != NULL) *phiconLarge = NULL;
	if(phiconSmall != NULL) *phiconSmall = NULL;
	fp = NULL;	/* ܂JĂȂ */
	image = NULL;	/* ܂쐬ĂȂ */
	mask = NULL;	/* ܂쐬ĂȂ */

	/* t@CJ܂B */
	fp = fopen(pszFile, "rb");
	if(fp == NULL) goto ERR;

	/* wb_ǂ݂܂B */
	retval = fread(&hdr, 1, sizeof hdr, fp);
	if(retval != sizeof hdr) goto ERR;

	/* ACR܂܂ĂȂ΁AftHgACRg܂B */
	if(hdr.ofs_icon == 0) goto ERR;

	/* ACRf[^̈ʒuփV[N܂B */
	retval = fseek(fp, hdr.ofs_icon, SEEK_SET);
	if(retval != 0) goto ERR;

	/* ACRf[^ǂݍ݂܂B */
	retval = fread(&pid[0][0], 1, sizeof pid, fp);
	if(retval != sizeof pid) goto ERR;

	/* ACRf[^rbg}bvɓWJ܂B */
	memset(&bi, 0, sizeof bi);
	bi.biSize = sizeof bi;
	bi.biWidth = ICON_SIZE;
	bi.biHeight = -ICON_SIZE; /* gbv_E */
	bi.biPlanes = 1;
	bi.biBitCount = 24;
	image = CreateDIBSection(NULL, (BITMAPINFO*)&bi, DIB_RGB_COLORS, (void**)&bits, NULL, 0);
	if(image == NULL) goto ERR;
	retval = GetObject(image, sizeof bm, &bm);
	if(retval != sizeof bm) goto ERR;
	for(y = 0; y < ICON_SIZE; y++) {
		pixel = bits + bm.bmWidthBytes * y;	/* C擪AhX */
		for(x = 0; x < ICON_SIZE; x++) {
			n = pid[y][x / 4];		/* 4sNZP */
			n = n >> (3 - (x & 3)) * 2;	/* ̃sNZbit0`1 */
			n = n & 3;			/* bit7`2}XN */
			n = n = 85 * (3 - n);		/* 0`3255,170,85,0 */
			*pixel++ = (unsigned char)n;	/* RGBɓl */
			*pixel++ = (unsigned char)n;
			*pixel++ = (unsigned char)n;
		}
	}

	/* ͂܂B
	 * }XNCreateDIBSection()ōƁAȂSɂȂ肵܂B
	 * (ȂȂƂ܂Bǂ킩܂B)
	 * dȂ̂ŁACreateBitmap()ł邱Ƃɂ܂B
	 */
	unsigned char buf[ICON_SIZE][(ICON_SIZE + 7) / 8];
	memset(buf, 0, sizeof buf);
	mask = CreateBitmap(ICON_SIZE, ICON_SIZE, 1, 1, &buf[0][0]);
	if(mask == NULL) goto ERR;

	/* rbg}bvACR쐬܂B */
	memset(&icon, 0, sizeof icon);
	icon.fIcon = TRUE;
	icon.hbmMask = mask;
	icon.hbmColor = image;
	if(phiconLarge != NULL) {
		/* TCY͖BTCYWindows܂B */
		*phiconLarge = CreateIconIndirect(&icon);
	}
	if(phiconSmall != NULL) {
		/* TCY͖BTCYWindows܂B */
		*phiconSmall = CreateIconIndirect(&icon);
	}
	/* FALL THRU */
ERR:
	/* rbg}bv폜܂B
	 * CreateIconIndirect()AArbg}bv͕svłB
	 */
	if(image != NULL) DeleteObject(image);
	if(mask != NULL) DeleteObject(mask);

	/* t@C܂B */
	if(fp != NULL) fclose(fp);

	/* vꂽACR쐬łĂȂ΁AftHgACRg܂B */
	if(phiconLarge != NULL && *phiconLarge == NULL) {
		*phiconLarge = LoadIcon(g_inst, MAKEINTRESOURCE(IDI_DEFAULT));
	}
	if(phiconSmall != NULL && *phiconSmall == NULL) {
		*phiconSmall = LoadIcon(g_inst, MAKEINTRESOURCE(IDI_DEFAULT));
	}

	/* Ȃ݂ɃACR̍폜̓VF͂łB
	 * VXeACRJX^ACRAǂċʂĂ̂킩܂񂪁A
	 * ȂƂł͍폜̃^C~O킩Ȃ͂B
	 * AACR̍폜̓VF͂łB
	 * gĂ݂āAGNXv[̃ĂȂ̂ŁA
	 * ԂvƎv܂B
	 */

	return S_OK; /* ɐ܂ */
}

